package com.seeyon.apps.ocip.webservice.impl;

import com.seeyon.apps.collaboration.manager.ColManager;
import com.seeyon.apps.ocip.util.CommonUtil;
import com.seeyon.apps.ocip.webservice.OcipBusinessService;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.workflow.exception.BPMException;
import com.seeyon.ctp.workflow.wapi.WorkflowApiManager;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.HashMap;
import java.util.Map;

public class OcipBusinessServiceImpl implements OcipBusinessService {
    private static final Log log = LogFactory.getLog(OcipBusinessServiceImpl.class);
    private ColManager colManager;
    private OrgManager orgManager;
    //private WorkflowAjaxManager WFAjax;
    private WorkflowApiManager wapi;


    public void setWapi(WorkflowApiManager wapi) {
		this.wapi = wapi;
	}

	public void setColManager(ColManager colManager) {
        this.colManager = colManager;
    }

    public void setOrgManager(OrgManager orgManager) {
        this.orgManager = orgManager;
    }

    @Override
    public String[] takeBack(String affairId, String isSaveOpinion, String outMemberId) {
        String[] ret = new String[2];
        setCurrentUser(outMemberId);
        try {
            Map<String, Object> param = new HashMap<String, Object>();
            param.put("affairId", affairId);
            param.put("isSaveOpinion", Boolean.valueOf(isSaveOpinion));
            String msg = colManager.transTakeBack(param);
            ret[0] = msg == null ? "" : msg;
        } catch (BusinessException e) {
            log.error("->", e);
        }
        return ret;
    }

    private void setCurrentUser(String memberId) {
        V3xOrgMember member = null;
        try {
            member = orgManager.getMemberById(Long.valueOf(memberId));
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (BusinessException e) {
            e.printStackTrace();
        }
        User user = new User();
        user.setId(Long.valueOf(member.getId()));
        user.setLoginAccount(member.getOrgAccountId());
        user.setAccountId(member.getOrgAccountId());
        user.setDepartmentId(member.getOrgDepartmentId());
        user.setName(member.getName());
        user.setLoginName(member.getLoginName());
        user.setAuditAdmin(true);
        //标记为外系统单点登录来的请求
        user.setUserSSOFrom("other");
        CommonUtil.setCurrentUser(user);
    }

    @Override
    public String canTakeBack(String appName, String processId, String activityId, String workitemId)
            throws BPMException {
        return wapi.canTakeBack(appName, processId, activityId, workitemId);
    }
}
